﻿using ProjectAccordionBus.Drawnings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectAccordionBus.CollectionGenericObjects;

public class BusSharingService : AbstractCompany
{
    public BusSharingService(int picWidth, int picHeight, ICollectionGenericObjects<DrawningBus> collection) : base(picWidth, picHeight, collection)
    {
    }


    protected override void DrawBackground(Graphics g)
    {
        Pen pen = new(Color.Black, 3);
        for (int i = 0; i <= _pictureWidth / _placeSizeWidth; i++)
        {
            for (int j = 0; j <= _pictureHeight / _placeSizeHeight; j++)
            {
                g.DrawLine(pen, i * _placeSizeWidth, j * _placeSizeHeight, i * _placeSizeWidth + _placeSizeWidth / 2, j * _placeSizeHeight);
            }
            g.DrawLine(pen, i * _placeSizeWidth, 0, i * _placeSizeWidth, _pictureHeight / _placeSizeHeight * _placeSizeHeight);
        }
    }

    protected override void SetObjectPosition(int position, int MaxPos, DrawningBus? bus)
    {
        int n = 0;
        int m = 0;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
            if (_collection?.Get(i) != null)
            {
                int x = 5 + _placeSizeWidth * n;
                int y = (10 + _placeSizeHeight * (_pictureHeight / _placeSizeHeight - 1)) - _placeSizeHeight * m;

                _collection?.Get(i)?.SetPictureSize(_pictureWidth, _pictureHeight);
                _collection?.Get(i)?.SetPosition(x, y);
            }

            if (n < _pictureWidth / _placeSizeWidth)
                n++;
            else
            {
                n = 0;
                m++;
            }
        }
    }
}

